class MachineryModal {

    static QUANTITY_PER_HOUR = 0;
    constructor(parent) {

        $.ajax({
            url: 'MachineryModal',
            type: 'GET',
            async: false,
            success: function (data) {
                parent.html($(data).find('#modal').html());
            }
        });




    }


    show() {

        $('#machinePlanModal').modal('show');
    }

    hide() {
        $('#machinePlanModal').modal('hide');
    }



    getSelectedModalData(order_id, product_id, machine_id) {
        $.ajax({
            type: 'GET',
            url: '/pd/ProductionScheduleCreateController/getSelectedProductData/' + order_id + "/" + product_id + "/" + machine_id,
            async: false,
            success: function (response) {
                console.log(response.data.result);
                if (response.data.success) {
                    $('#lblProductCode').text(": " + response.data.result.product_code);
                    $('#lblProductName').text(": " + response.data.result.product_name);
                    $('#lblFactoryPO').text(": " + response.data.result.factory_po);
                    $('#lblCustomerPO').text(": " + response.data.result.customer_po);
                    $('#lblProductionQty').text(": " + response.data.result.quantity);
                    $('#lblAllocateQty').text(": " + response.data.result.allocated_quantity);
                    $('#lblFactory').text(": " + response.data.result.factory);
                    $('#lblMachine').text(": " + response.data.result.machine);
                    MachineryModal.QUANTITY_PER_HOUR = MachineryModal.quantityPerHour(machine_id);
                    MachineryModal.getAllocatedSummaryData(order_id, product_id, machine_id);
                }

            },
            error: function (data) {
                console.log(error);
                showErrorMessage();
            },
            complete: function () {

            }
        });
    }





    static getAllocatedSummaryData(order_id, product_id, machine_id) {

        $.ajax({
            type: 'GET',
            url: '/pd/ProductionScheduleCreateController/getAllocatedData/' + order_id + "/" + product_id + "/" + machine_id,
            async: false,
            beforeSend: function () {
                //progress(true);
            },
            success: function (response) {
                console.log(response.data.result);
                $('#tblAllocateProduct').empty();
                if (response.data.success) {

                    var result_arr = [];
                    for (i = 0; i < response.data.result.length; i++) {
                        var date = response.data.result[i]['date'];
                        var from = response.data.result[i]['from'];
                        var to = response.data.result[i]['to'];
                        var quantity = response.data.result[i]['quantity'];
                        var maxout = MachineryModal.maxOutPut(from, to);
                        var allocated = MachineryModal.getAllocatedQuantityFromDate(order_id, product_id, machine_id, date, from, to);
                        var shift = response.data.result[i]['shift_name'];

                        var row = '<tr><td>' + date + '</td>';
                        row += '<td>' + from + '</td>';
                        row += '<td>' + to + '</td>';
                        row += '<td style="text-align:right;">' + quantity + '</td>';
                        row += '<td style="text-align:right;">' + maxout + '</td>';
                        row += '<td style="text-align:right;">' + allocated + '</td>';
                        row += '<td>' + shift + '</td></tr>';
                        $('#tblAllocateProduct').append(row);

                    }

                }


            },
            error: function (data) {

            },
            complete: function () {
                //progress(false);
            }
        });

    }



    static maxOutPut(from, to) {

        return (parseFloat(to) - parseFloat(from)) * this.QUANTITY_PER_HOUR;
    }



    static getAllocatedQuantityFromDate(order_id, product_id, machine_id, date, from, to) {

        var quantity = 0;
        $.ajax({
            type: 'GET',
            url: '/pd/ProductionScheduleCreateController/getAllocatedQuantityFromDate/' + order_id + "/" + product_id + "/" + machine_id + "/" + date + "/" + from + "/" + to,
            async: false,
            success: function (response) {
                console.log(response.data.result);
                if (response.data.result != null) {
                    quantity = response.data.result;
                }
            },
            error: function (data) {

            },
            complete: function () {

            }
        });
        return quantity;
    }



    static quantityPerHour(machine_id) {
        var quantity = 0;
        $.ajax({
            type: 'GET',
            url: '/pd/ProductionScheduleCreateController/quantityPerHour/' + machine_id,
            async: false,
            success: function (response) {
                console.log(response.data.result);

                quantity = parseFloat(response.data.result);
            },
            error: function (data) {

            },
            complete: function () {

            }
        });
        return quantity;
    }




}